GetPlayer = GLOBAL.GetPlayer
local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

PrefabFiles = {
    "kangna",
    "kangna_bag",
    "kangna_battery",
}

Assets = {


    Asset( "IMAGE", "images/saveslot_portraits/kangna.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/kangna.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/kangna.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/kangna.xml" ),
    
    Asset( "IMAGE", "images/selectscreen_portraits/kangna_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/kangna_silho.xml" ),

    Asset( "IMAGE", "bigportraits/kangna.tex" ),
    Asset( "ATLAS", "bigportraits/kangna.xml" ),
    
    Asset( "IMAGE", "images/map_icons/kangna.tex" ),
    Asset( "ATLAS", "images/map_icons/kangna.xml" ),
    
    Asset( "IMAGE", "images/avatars/avatar_kangna.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_kangna.xml" ),
    
    Asset( "IMAGE", "images/avatars/avatar_ghost_kangna.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_kangna.xml" ),
    
    Asset( "IMAGE", "images/avatars/self_inspect_kangna.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_kangna.xml" ),

    Asset("ANIM", "anim/manaindicator.zip"),

    Asset( "ATLAS", "images/kangnatab.xml" ),

    --Asset("ANIM", "anim/lightning_rod_fx.zip"),

    --Asset( "IMAGE", "images/inventoryimages/kangna_hat.tex" ),
    --Asset( "ATLAS", "images/inventoryimages/kangna_hat.xml" ),
    

}

--local prefabs =
--{
--  "lightning_rod_fx",
--}

--local function dozap(inst)
--    if inst.zaptask ~= nil then
--       inst.zaptask:Cancel()
--    end
--    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
--    SpawnPrefab("lightning_rod_fx").Transform:SetPosition(inst.Transform:GetWorldPosition())
--    inst.zaptask = inst:DoTaskInTime(math.random(10, 40), dozap)
--end


-- The character select screen lines
STRINGS.CHARACTER_TITLES.kangna = "康娜 卡姆依"
STRINGS.CHARACTER_NAMES.kangna = "kangna"
STRINGS.CHARACTER_DESCRIPTIONS.kangna = "阿伊努族的雷灵 \n萌萌哒 \n不得了了"
STRINGS.CHARACTER_QUOTES.kangna = "\"不得了了\""


kangnatab = AddRecipeTab("kangna", 667, "images/kangnatab.xml", "kangnatab.tex", "kangna_skiller")
local kangna_battery = AddRecipe("kangna_battery",
{Ingredient("cutstone", 2), Ingredient("lightninggoathorn", 1)}, 
kangnatab, TECH.NONE,
nil, nil, nil, 4, "kangna_skiller",
"images/kangna_battery.xml", "kangna_battery.tex")
STRINGS.NAMES.KANGNA_BATTERY = "康娜的充电宝"
STRINGS.RECIPE_DESC.KANGNA_BATTERY = "补充20点能量"

local kangna_battery = AddRecipe("kangna_bag",
{Ingredient("silk", 4), Ingredient("rope", 4), Ingredient("goldnugget", 1)}, 
kangnatab, TECH.NONE,
nil, nil, nil, nil, "kangna_skiller",
"images/kangna_bag.xml", "kangna_bag.tex")
STRINGS.NAMES.KANGNA_BAG = "康娜的书包"
STRINGS.RECIPE_DESC.KANGNA_BAG = "吸了人血的诅咒道具"


local params={}
params.kangna_bag =
{
    widget =
    {
        slotpos = {},
        animbank = "ui_piggyback_2x6",
        animbuild = "ui_piggyback_2x6",
        pos = Vector3(-5, -50, 0),
    },
    issidewidget = true,
    type = "pack",
}
for y = 0, 5 do
    table.insert(params.kangna_bag.widget.slotpos, Vector3(-162, -75 * y + 170, 0))
    table.insert(params.kangna_bag.widget.slotpos, Vector3(-162 + 75, -75 * y + 170, 0))
end
local containers = require "containers"
containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, params.kangna_bag.widget.slotpos ~= nil and #params.kangna_bag.widget.slotpos or 0)
local old_widgetsetup = containers.widgetsetup
function containers.widgetsetup(container, prefab, data)
    local pref = prefab or container.inst.prefab
    if pref == "kangna_bag" then
        local t = params[pref]
        if t ~= nil then
            for k, v in pairs(t) do
                container[k] = v
            end
        container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
        end
    else
        return old_widgetsetup(container, prefab)
    end
end

-- The character's name as appears in-game 
STRINGS.NAMES.kangna = "Esc"

-- UI
local manaindicator = require("widgets/manaindicator")
local function AddManaIndicator(self)
    if self.owner and self.owner:HasTag("kangna") then
        self.manaindicator = self:AddChild(manaindicator(self.owner))
        self.manaindicator:SetPosition(120,70,0)
        self.manaindicator:SetHAnchor(1)
        self.manaindicator:SetVAnchor(2)
        self.manaindicator:MoveToFront()
    end
end
AddClassPostConstruct("widgets/controls", AddManaIndicator)

AddMinimapAtlas("images/map_icons/kangna.xml")

local characterName = "kangna"


local skill_valid={
    z={validfn=function(inst, x, y, z)
        if inst.sg and not inst.sg:HasStateTag("busy") and not ThePlayer:HasTag("playerghost") then
            return inst["z_skill"]
        end
    end,cd=20},
}

local skill_valid2={
    z={validfn=function(inst, x, y, z)
        return skill_valid.z.validfn(inst, x, y, z)
    end},
}

local skills = {
    z = function(inst, x, y, z)
          if inst.components.mana:GetPercent() >= 0 then
            inst.is_sLight=true
            --dozap(inst)
            inst:DoTaskInTime(20, function()
                inst.is_sLight=false
            end)
          end
        end,
}
for key, v in pairs(skills) do
    AddModRPCHandler(characterName, key.."_skill", v)
end

local handlers = {}
AddPlayerPostInit(function(inst)
    if inst.prefab == characterName then
        inst:AddComponent("timer")
        inst:ListenForEvent("timerdone", function(inst, data) inst[data.name] = true end)
        for key, v in pairs(skill_valid) do
            inst[key.."_skill"] = true     
            if not ( inst[key.."_skill"] or inst.components.timer:TimerExists(key.."_skill") ) then
                inst.components.timer:StartTimer(key.."_skill", v.cd)
            end
        end
        for key, v in pairs(skill_valid) do
            handlers[key] = TheInput:AddKeyDownHandler(GLOBAL["KEY_"..(string.upper(key))], function() 
                if inst == ThePlayer then
                    local x, y, z = ( TheInput:GetWorldPosition() or Vector3(0,0,0) ):Get()
                    local screen = TheFrontEnd:GetActiveScreen()
                    local IsHUDActive = screen and screen.name == "HUD"
                    if inst:IsValid() and skill_valid2[key].validfn(inst, x, y, z) and IsHUDActive then
                        inst[key.."_skill"] = false
                        if not ( inst[key.."_skill"] or inst.components.timer:TimerExists(key.."_skill") ) then
                            inst.components.timer:StartTimer(key.."_skill", v.cd)
                        end
                        SendModRPCToServer(MOD_RPC[characterName][key.."_skill"], x, y, z) 
                    end
                end
            end)
        end
    end
end)
local skillsbutton = require("widgets/"..characterName.."_skillbutton")
local base_x = -750
local delta_x = 175
local function AddSkillButton(self) 
    if self.owner and self.owner:HasTag(characterName.."_skiller") then 
        self.skillbutton_z = self:AddChild( skillsbutton(nil, nil, base_x,nil,nil,"发光","0.2/1") )    
        local old_OnUpdate = self.OnUpdate
        self.OnUpdate = function(self, dt)
            old_OnUpdate(self, dt)
            local x, y, z = ( TheInput:GetWorldPosition() or Vector3(0,0,0) ):Get()
            for key in pairs(skills) do
                if self.owner[key.."_skill"] ~= true then
                    self["skillbutton_"..key]:SetTint(0.2,0.2,0.2,1)
                    self["skillbutton_"..key]:SetColour(1,0,0,1)
                    self["skillbutton_"..key]:SetString( math.ceil( self.owner.components.timer:GetTimeLeft(key.."_skill") or 0) )
                elseif skill_valid[key].validfn(self.owner, x, y, z) ~= true then
                    self["skillbutton_"..key]:SetTint(0.2,0.2,0.2,1)
                    self["skillbutton_"..key]:SetColour(1,0,0,1)
                    self["skillbutton_"..key]:SetString(string.upper(key))
                else
                    self["skillbutton_"..key]:SetTint(1,1,1,1)
                    self["skillbutton_"..key]:SetColour(0,1,0,1)
                    self["skillbutton_"..key]:SetString(string.upper(key))
                end
            end
        end
    end
end
AddClassPostConstruct("widgets/inventorybar", AddSkillButton)


-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("kangna", "MALE")



