

local MakePlayerCharacter = require "prefabs/player_common"


local assets = {
    Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
    Asset( "ANIM", "anim/kangna.zip" ),
    Asset( "ANIM", "anim/ghost_kangna_build.zip" ),
	
}

-- Custom starting items
local start_inv = {
"kangna_bag",
"kangna_battery",
}

local function updatemana(inst, phase)
	if phase == "day" then
	if inst.umana ~= nil then
       inst.umana:Cancel()
    end	
	elseif phase == "night" then
	inst.umana=inst:DoPeriodicTask(2,function()
	local pos = Vector3(inst.Transform:GetWorldPosition())
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 5)
    for k,v in pairs(ents) do
        if v:HasTag("lightningrod") then
        inst.components.mana:DoDelta(2)
        end
    end
	end)
	elseif phase == "dusk" then
	if inst.umana ~= nil then
       inst.umana:Cancel()
    end
	end
end

local function onlightingstrike(inst)
    if inst.components.health ~= nil and not (inst.components.health:IsDead() or inst.components.health:IsInvincible()) then
       inst.components.mana:DoDelta(20)
    end
end

local function cc(inst, data)
  
  if inst.components.mana:GetPercent() >= .95 then
  	inst.components.combat.damagemultiplier = 10
  	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 2.5 )
    inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 2.5 )

  elseif inst.components.mana:GetPercent() >= .8 then
  	inst.components.combat.damagemultiplier = 5
  	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 2 )
    inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 2 )

  elseif inst.components.mana:GetPercent() >= .7  then
  	inst.components.combat.damagemultiplier = 2.5
  	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 1.5 )
    inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 1.5 )

  elseif inst.components.mana:GetPercent() >= .4  then
	inst.components.combat.damagemultiplier = 1.5
	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 1.2 )
    inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 1.2 )

  elseif inst.components.mana:GetPercent() >= .2  then
	inst.components.combat.damagemultiplier = 1.0
	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 1.0 )
    inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED *  1.0 )

  else
	inst.components.combat.damagemultiplier = 0.4
    inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * .5 )
    inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * .5 )
  end	    
end

local function Attack(inst)
	inst.components.mana:DoDelta(-0.5)
end

local function applyupgrades(inst)

	local max_upgrades = 100
	local upgrades = math.min(inst.level, max_upgrades)

	local hunger_percent = inst.components.hunger:GetPercent()
	local health_percent = inst.components.health:GetPercent()
	local sanity_percent = inst.components.sanity:GetPercent()

	inst.components.hunger.max = math.ceil (100 + upgrades * 2) --300
	inst.components.health.maxhealth = math.ceil (150 + upgrades * 4) --450
	inst.components.sanity.max = math.ceil (150 + upgrades * 3) --450

	inst.components.hunger:SetPercent(hunger_percent)
	inst.components.health:SetPercent(health_percent)
	inst.components.sanity:SetPercent(sanity_percent)
	
end

local function oneat(inst, food)
	if food and food.components.edible and food.prefab == "butterflywings"  then
		if math.random() <= 0.4 then
		inst.level = inst.level + 1
		applyupgrades(inst)	
		inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		end    
	elseif food and food.components.edible and food.prefab == "smallmeat"  then
		if math.random() <= 0.1 then
		inst.level = inst.level + 1
		applyupgrades(inst)	
		inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		end
	elseif food and food.components.edible and food.prefab == "froglegs"  then
		if math.random() <= 0.2 then
		inst.level = inst.level + 1
		applyupgrades(inst)	
		inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		end
	end
	if food and food.components.edible and food.prefab == "monstermeat"  then
        inst.components.mana:DoDelta(-2)
	end
end

local function onpreload(inst, data)
	if data then
		if data.level then
			inst.level = data.level
			applyupgrades(inst)
			--re-set these from the save data, because of load-order clipping issues
			if data.health and data.health.health then inst.components.health.currenthealth = data.health.health end
			if data.hunger and data.hunger.hunger then inst.components.hunger.current = data.hunger.hunger end
			if data.sanity and data.sanity.current then inst.components.sanity.current = data.sanity.current end
			inst.components.health:DoDelta(0)
			inst.components.hunger:DoDelta(0)
			inst.components.sanity:DoDelta(0)
		end
	end
end

local function onsave(inst, data)
	data.level = inst.level
	data.charge_time = inst.charge_time
end

-- When the character is revived from human
local function onbecamehuman(inst)
	-- Set speed when reviving from ghost (optional)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "kangna_speed_mod", 1)
end

local function onbecameghost(inst)
	-- Remove speed modifier when becoming a ghost
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "kangna_speed_mod")
end

-- When loading or spawning the character
local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end


-- This initializes for both the server and client. Tags can be added here.
local common_postinit = function(inst) 
	-- Minimap icon
	inst.currentmana = net_shortint(inst.GUID,"currentmana")
	inst.MiniMapEntity:SetIcon( "kangna.tex" )
	inst:AddTag("kangna")
	inst:AddTag("kangna_skiller")
end

-- This initializes for the server only. Components are added here.
local master_postinit = function(inst)
	-- choose which sounds this character will play
	inst.soundsname = "willow"
	-- Stats
        inst.components.eater.ignoresspoilage = true
        inst.components.eater.strongstomach = true
        inst.components.eater.monsterimmune = true	
	--inst.components.health:SetMaxHealth(500)
        inst.components.health:StartRegen(1, 5)
	--inst.components.hunger:SetMax(300)
	--inst.components.sanity:SetMax(500)
        --inst.components.sanity.dapperness = 20/60
	inst.components.sanity.neg_aura_mult = 0

	-- Movement Speed
	--inst.components.locomotor.triggerscreep = false

	-- Damage multiplier (optional)
	inst.components.health.absorb = 0.5
    inst.components.health.fire_damage_scale = 0
    
    inst.components.playerlightningtarget:SetHitChance(1)
    inst.components.playerlightningtarget:SetOnStrikeFn(onlightingstrike)

	-- Hunger rate (optional)
	inst.components.hunger.hungerrasate = 1.5 * TUNING.WILSON_HUNGER_RATE
	inst.components.combat.min_attack_period = 0.1

    --inst.components.builder.science_bonus = 1

	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	
    inst:AddComponent("mana")
 
	-- Animals dont need to cook
	inst.components.eater:SetCanEatRaw()
        inst.components.eater:SetOnEatFn(oneat)
        inst.level = 0
        applyupgrades(inst)
	
	inst.OnSave = onsave
	inst.OnPreLoad = onpreload

	-- Floof shall keep thee warm
	inst:WatchWorldState("phase", updatemana)
	inst:ListenForEvent("Mana_delta", cc)
	inst:ListenForEvent("onhitother",Attack)

    inst:DoPeriodicTask(1,function()
		if not inst.components.health:IsDead() and not inst:HasTag("playerghost") then
			if inst.is_sLight then 
				inst.Light:Enable(true)
				    local light = inst.entity:AddLight()
                    inst.Light:SetRadius(4)
                    inst.Light:SetFalloff(0.66)
                    inst.Light:SetIntensity(.66)
                    inst.Light:SetColour(180/255,180/255,180/255)
				inst.components.mana:DoDelta(-0.2)
			else
				inst.Light:Enable(false)
			end
		end
	end)

    inst:DoPeriodicTask(1,function()
		if not inst.components.health:IsDead() and not inst:HasTag("playerghost") and inst:HasTag("cdb") then
			inst.components.mana:DoDelta(2)
		end
	end)

    
end

return MakePlayerCharacter("kangna", prefabs, assets, common_postinit, master_postinit, start_inv)
