local assets = 
{
	Asset("ANIM", "anim/kangna_bag.zip"),
	Asset( "ATLAS", "images/kangna_bag.xml" ),
}

local function onequip(inst, owner)
    if inst.components.container ~= nil then
        inst.components.container:Open(owner)
        
        
    end
end

local function onunequip(inst, owner)
    if inst.components.container ~= nil then
        inst.components.container:Close(owner)
    end
end


local function fn()

    local inst = CreateEntity()
    
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()



    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("izayoi_watch")
    inst.AnimState:SetBuild("kangna_bag")
    inst.AnimState:PlayAnimation("idle")

	inst.entity:SetPristine()
	
    inst:AddTag("backpack")

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_ABSOLUTE)

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "kangna_bag"
    inst.components.inventoryitem.atlasname = "images/kangna_bag.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_SMALL
	
	inst:AddComponent("container")
	inst.components.container:WidgetSetup("kangna_bag")
	
    return inst
end

return  Prefab("kangna_bag", fn, assets)