local assets = 
{
    Asset("ANIM", "anim/kangna_battery.zip"),
    Asset( "ATLAS", "images/kangna_battery.xml" ),
}

local function onequip(inst, owner)
    if inst.components.fueled then
        inst.components.fueled:StartConsuming()
        owner:AddTag("cdb")
    end
end

local function onunequip(inst, owner)
    if inst.components.fueled then
        inst.components.fueled:StopConsuming()
        owner:RemoveTag("cdb")
    end
end


local function fn()

    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()



    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("izayoi_watch")
    inst.AnimState:SetBuild("kangna_battery")
    inst.AnimState:PlayAnimation("idle")

    inst.entity:SetPristine()
    
    if not TheWorld.ismastersim then
        return inst
    end
    

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "kangna_battery"
    inst.components.inventoryitem.atlasname = "images/kangna_battery.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = TUNING.kangna_battery_SLOT==2 and (EQUIPSLOTS.ZGAMULET or EQUIPSLOTS.NECK or EQUIPSLOTS.BODY) or EQUIPSLOTS.BODY
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    
    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = FUELTYPE.USAGE
    inst.components.fueled:InitializeFuelLevel(10)
    inst.components.fueled:SetDepletedFn(inst.Remove)
    

    return inst
end

return  Prefab("kangna_battery", fn, assets)